#include "base.hpp"

using namespace cv;
using namespace std;

Point Pos =  Point(50, 50);

void Base(void)
{
   Mat M(200,100, CV_8UC3, Scalar(0,0,255));   			// https://docs.opencv.org/3.4.18/d3/d63/classcv_1_1Mat.html#a2ec3402f7d165ca34c7fd6e8498a62ca
   std::cout << "M = " << endl << " " << M << endl << endl;

    ellipse(   M,
    		   Pos,
    	       Size( 5, 5 ),
    	       10,
    	       0,
    	       360,
    	       Scalar( 255, 0, 0 ),
    	       2,
    	       8
    	       );

    namedWindow( "1", WINDOW_AUTOSIZE );
    imshow( "1", M );


    Mat N(200,100, CV_8UC3, Scalar(255,0,255));
    cout << "N = " << endl << " " << N << endl << endl;

    namedWindow( "2", WINDOW_AUTOSIZE );
    imshow( "2", N );
    waitKey(0);
}
