/*
 * video.cpp
 *
 *  Created on: 7 janv. 2021
 *      Author: kerhoas
 */

#include "video.hpp"

using namespace cv;
using namespace std;

void RedDetect( Mat);
void Sharpen(Mat);

int h = 0, s = 0, v = 0, tolerance = 10;
//====================================================================
int DisplayVideo()
{
	  //CvCapture* capture;
    VideoCapture capture;
	  Mat frame;

	  frame= capture.open("/dev/video0");

	  if( capture.isOpened() )
	    {
	      for(;;)
	      {
	    	capture.read(frame);

	        if( !frame.empty() )
	         {
	        	imshow( "capture", frame );
	        	RedDetect(frame);
	        	//Sharpen(frame);
	         }
	        else
	         { printf(" --(!) No captured frame -- Break!"); break; }

	        int c = waitKey(10);
	        if( (char)c == 'c' ) { break; }

	      }
	    }


	return 0;
}
//====================================================================
void RedDetect( Mat frame )
	{
	   Mat frame_hsv;
	   //int sommeX = 0, sommeY = 0;
			   int nbPixels = 0;
	   Point objectPos =  Point(-1, -1);

	   // CONVERSION BGR --> HSV (couleurs + facilement détectables) AVEC cvtColor
	   // frame --> frame_hsv
	   // https://docs.opencv.org/3.4.18/d8/d01/group__imgproc__color__conversions.html#ga397ae87e1288a81d2363b61574eb8cab
	   /* A Compléter */
	   //imshow("Capture -hsv", frame_hsv);

	   // CONSTRUCTION DE frame_gray : Objet Mat N&B de même taille (lignes et colonnes) que frame_hsv
	   /* A Compléter */

	   // DETECTION DU ROUGE AVEC inRange --> Résultat dans Mask
	   // https://docs.opencv.org/3.4.18/d2/de8/group__core__array.html#ga48af0ab51e36436c5d04340e036ce981inrange
	   // void inRange(InputArray src, InputArray lowerb, InputArray upperb, OutputArray dst)
	   // lowerb=cv::Scalar(159, 135, 135), upperb=cv::Scalar(179, 255, 255)
	   /* A Compléter */

	   //imshow("Capture - N&B", frame_gray);

	   // RECHERCHE DU BARYCENTRE --> Parcours de l'image N&B cf algos de image.cpp
	   /* A Compléter */

	   // ON TRACE UNE ELLIPSE DANS FRAME DONT LE CENTRE EST LE BARYCENTRE
	   // Définition du Centre
	   if(nbPixels > 0)
	   {
		   /* A Compléter */
	   }
	    else
	    {
	    objectPos=Point(-1, -1);
	    }
	   	   // Tracé de l'ellipse ( cf base.cpp )


	   /* A Compléter */



	imshow( "Capture - Red Detection", frame);
}

//====================================================================
// 								Sharpen
// 			Image + contrastée
// 			sharpened_pixel= 5*current-left-right-up-down;
 //====================================================================

// Penser à saturer la valeur calculée avec saturate_cast<uchar>()
//https://docs.opencv.org/3.4.18/db/de0/group__core__utils.html#gab93126370b85fda2c8bfaf8c811faeaf

void Sharpen(Mat myImage)
{
	Mat Result;
    CV_Assert(myImage.depth() == CV_8U);  // accept only uchar images

    Result.create(myImage.size(),myImage.type());
//    const int nChannels = myImage.channels();

	   /* A Compléter */

    // Set the unprocess pixels to 0
    Result.row(0).setTo(Scalar(0));
    Result.row(Result.rows-1).setTo(cv::Scalar(0));
    Result.col(0).setTo(Scalar(0));
    Result.col(Result.cols-1).setTo(Scalar(0));

    imshow( "Sharpen", Result );
}


